---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_ospf Data Source - terraform-provider-iosxe"
subcategory: "OSPF"
description: |-
  This data source can read the OSPF configuration.
---

# iosxe_ospf (Data Source)

This data source can read the OSPF configuration.

## Example Usage

```terraform
data "iosxe_ospf" "example" {
  process_id = 1
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `process_id` (Number) Process ID

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `bfd_all_interfaces` (Boolean) Enable BFD on all interfaces
- `default_information_originate` (Boolean) Distribute a default route
- `default_information_originate_always` (Boolean) Always advertise default route
- `default_metric` (Number) Set metric of redistributed routes
- `distance` (Number) Administrative distance
- `domain_tag` (Number) OSPF domain-tag
- `id` (String) The path of the retrieved object.
- `mpls_ldp_autoconfig` (Boolean) Configure LDP automatic configuration
- `mpls_ldp_sync` (Boolean) Configure LDP-IGP Synchronization
- `neighbor` (Attributes List) Specify a neighbor router (see [below for nested schema](#nestedatt--neighbor))
- `network` (Attributes List) Enable routing on an IP network (see [below for nested schema](#nestedatt--network))
- `priority` (Number) OSPF topology priority
- `router_id` (String) Override configured router identifier (peers will reset)
- `shutdown` (Boolean) Shutdown the OSPF protocol under the current instance
- `summary_address` (Attributes List) Configure IP address summaries (see [below for nested schema](#nestedatt--summary_address))

<a id="nestedatt--neighbor"></a>
### Nested Schema for `neighbor`

Read-Only:

- `cost` (Number) OSPF cost for point-to-multipoint neighbor
- `ip` (String) Neighbor address
- `priority` (Number) OSPF priority of non-broadcast neighbor


<a id="nestedatt--network"></a>
### Nested Schema for `network`

Read-Only:

- `area` (String) Set the OSPF area ID
- `ip` (String) Network number
- `wildcard` (String) OSPF wild card bits


<a id="nestedatt--summary_address"></a>
### Nested Schema for `summary_address`

Read-Only:

- `ip` (String) IP summary address
- `mask` (String) Summary mask


