---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_restconf Data Source - terraform-provider-iosxe"
subcategory: "General"
description: |-
  This data source can retrieve one or more attributes via RESTCONF.
---

# iosxe_restconf (Data Source)

This data source can retrieve one or more attributes via RESTCONF.

## Example Usage

```terraform
data "iosxe_restconf" "example" {
  path = "Cisco-IOS-XE-native:native/banner/login"
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `path` (String) A RESTCONF path, e.g. `openconfig-interfaces:/interfaces`.

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `attributes` (Map of String) Map of key-value pairs which represents the attributes and its values.
- `id` (String) The path of the retrieved object.


