---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_static_route Data Source - terraform-provider-iosxe"
subcategory: "Routing"
description: |-
  This data source can read the Static Route configuration.
---

# iosxe_static_route (Data Source)

This data source can read the Static Route configuration.

## Example Usage

```terraform
data "iosxe_static_route" "example" {
  prefix = "5.5.5.5"
  mask   = "255.255.255.255"
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `mask` (String)
- `prefix` (String)

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `id` (String) The path of the retrieved object.
- `next_hops` (Attributes List) (see [below for nested schema](#nestedatt--next_hops))

<a id="nestedatt--next_hops"></a>
### Nested Schema for `next_hops`

Read-Only:

- `global` (Boolean) Next hop address is global
- `metric` (Number)
- `name` (String) Specify name of the next hop
- `next_hop` (String)
- `permanent` (Boolean) permanent route
- `tag` (Number) Set tag for this route


