---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_restconf Resource - terraform-provider-iosxe"
subcategory: "General"
description: |-
  Manages IOS-XE objects via RESTCONF calls. This resource can only manage a single object. It is able to read the state and therefore reconcile configuration drift.
---

# iosxe_restconf (Resource)

Manages IOS-XE objects via RESTCONF calls. This resource can only manage a single object. It is able to read the state and therefore reconcile configuration drift.

## Example Usage

```terraform
resource "iosxe_restconf" "example" {
  path = "Cisco-IOS-XE-native:native/banner/login"
  attributes = {
    banner = "My Banner"
  }
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `path` (String) A RESTCONF path, e.g. `openconfig-interfaces:/interfaces`.

### Optional

- `attributes` (Map of String) Map of key-value pairs which represents the attributes and its values.
- `delete` (Boolean) Delete object during destroy operation. Default value is `true`.
- `device` (String) A device name from the provider configuration.

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_restconf.example "Cisco-IOS-XE-native:native/banner/login"
```
