// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"fmt"
	"strconv"

	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/netascode/terraform-provider-iosxe/internal/provider/helpers"
	"github.com/tidwall/gjson"
	"github.com/tidwall/sjson"
)

type Username struct {
	Device             types.String `tfsdk:"device"`
	Id                 types.String `tfsdk:"id"`
	Name               types.String `tfsdk:"name"`
	Privilege          types.Int64  `tfsdk:"privilege"`
	Description        types.String `tfsdk:"description"`
	PasswordEncryption types.String `tfsdk:"password_encryption"`
	PasswordPassword   types.String `tfsdk:"password"`
	SecretEncryption   types.String `tfsdk:"secret_encryption"`
	SecretSecret       types.String `tfsdk:"secret"`
}

func (data Username) getPath() string {
	return fmt.Sprintf("Cisco-IOS-XE-native:native/username=%s", data.Name.Value)
}

func (data Username) toBody() string {
	body := `{"` + helpers.LastElement(data.getPath()) + `":{}}`
	if !data.Name.Null && !data.Name.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"name", data.Name.Value)
	}
	if !data.Privilege.Null && !data.Privilege.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"privilege", strconv.FormatInt(data.Privilege.Value, 10))
	}
	if !data.Description.Null && !data.Description.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"description", data.Description.Value)
	}
	if !data.PasswordEncryption.Null && !data.PasswordEncryption.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"password.encryption", data.PasswordEncryption.Value)
	}
	if !data.PasswordPassword.Null && !data.PasswordPassword.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"password.password", data.PasswordPassword.Value)
	}
	if !data.SecretEncryption.Null && !data.SecretEncryption.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"secret.encryption", data.SecretEncryption.Value)
	}
	if !data.SecretSecret.Null && !data.SecretSecret.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"secret.secret", data.SecretSecret.Value)
	}
	return body
}

func (data *Username) fromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "privilege"); value.Exists() {
		data.Privilege.Value = value.Int()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "description"); value.Exists() {
		data.Description.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "password.encryption"); value.Exists() {
		data.PasswordEncryption.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "password.password"); value.Exists() {
		data.PasswordPassword.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "secret.encryption"); value.Exists() {
		data.SecretEncryption.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "secret.secret"); value.Exists() {
		data.SecretSecret.Value = value.String()
	}
}

func (data *Username) fromPlan(plan Username) {
	data.Device = plan.Device
	data.Name.Value = plan.Name.Value
}
